/* =========================================================================

InDesign ExtendScript

NAME: Fractions ()
VERSION: 1.0 

AUTHOR: Vitaly Batushev
DATE  : 09.04.2004

DESCRIPTION:      +  + ,  
   (, 1 1/2),    :
)  
) .
            ,
   Adobe InDesign CS, - Minion Pro  Myriad Pro,  
     (serif)   (sans-serif) .
  :
) Fraction Slash -    ,   .
)     (   ,   
    ).
) Figure Dash -        Minion Pro,    
    (  ).    Myriad Pro
      ,   1 pt.

SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */

with(app) {

if(documents.length < 1) {
	alert('No open documents');
	exit();
}
var myDoc = activeDocument;

if (selection.length < 1) {
	alert('No selected text');
	exit();
}

if (selection[0].constructor.name == 'Text' || selection[0].constructor.name == 'TextFrame'){
	var myDlg = dialogs.add({name: "Fractions"});
	with (myDlg) {
		with (dialogColumns.add())	{
		with (borderPanels.add()){
		var myLabel1 = staticTexts.add({staticLabel:"Use in fractions"});
		with (radiobuttonGroups.add()) {
			var MinionFont = radiobuttonControls.add({staticLabel: 'Serif Font (Minion Pro)', checkedState: true});
			var MyryadFont = radiobuttonControls.add({staticLabel: 'SansSerif Font (Myriad Pro)', checkedState: false});
		}} 
		with (borderPanels.add()){
		var myLabel2 = staticTexts.add({staticLabel:"Type of fractions"});
		with (radiobuttonGroups.add()) {
			var VulgarFraction = radiobuttonControls.add({staticLabel: 'Diagonal Fractions (1/2)', checkedState: true});
			var NonVulgarFraction = radiobuttonControls.add({staticLabel: 'Horizontal Fractions (1|2)', checkedState: false});
		}}
		}
	}
	var result = myDlg.show();
	
	if (result == true) {
	if (selection[0].constructor.name == 'Text') { var myStory = selection[0].texts[0]; }
	if (selection[0].constructor.name == 'TextFrame') { var myStory = selection[0].parentStory; }
	
	if (MinionFont.checkedState == true) {
		var myFont  = 'Minion Pro';
	} else {
		var myFont  = 'Myriad Pro';
	}
		
	findPreferences = undefined;
	changePreferences = undefined;
	
	var myRange = new Array();
	myRange = myStory.search("^9"+ "/" + "^9", false, false);

	if (myRange.length > 0) {

	if (VulgarFraction.checkedState == true) {
		var myNameStyle = 'DiagonalFractionStyle';
		if ( myFont == 'Minion Pro') {
			myMyStyleTracking = -100;
		} else {
			myMyStyleTracking = -200;
		}
		var myFrSlash = '\u2044';
	} else {
		var myNameStyle = 'HorizontalFractionStyle';
		myMyStyleTracking = -400;
		if ( myFont == 'Minion Pro') {
			var myFrSlash = '\u2012';
		} else {
			var myFrSlash = '\u2013';
		}
	}
	// Create Style
		var myMyFractStyle;
		myMyFractStyle = activeDocument.characterStyles.item(myNameStyle);
		try { myMyFractStyle.name; }
		catch (myError){
			myMyFractStyle = activeDocument.characterStyles.add({name:myNameStyle});
		}
		myMyFractStyle.appliedFont = myFont;
		myMyFractStyle.tracking = myMyStyleTracking;
	
		for ( i = 0 ; i < myRange.length; i++)
		{
			var mySearch = myRange[i].contents;
			switch (myRange[i].characters[0].contents) 
			{
			   case '1':
			      var myFSymbol = '\u00B9';
			      break;
			   case '2':
			      var myFSymbol = '\u00B2';
			      break;
			   case '3':
			      var myFSymbol = '\u00B3';
			      break;
			   case '4':
			      var myFSymbol = '\u2074';
			      break;
			   case '5':
			      var myFSymbol = '\u2075';
			      break;
			   case '6':
			      var myFSymbol = '\u2076';
			      break;
			   case '7':
			      var myFSymbol = '\u2077';
			      break;
			   case '8':
			      var myFSymbol = '\u2078';
			      break;
			   case '9':
			      var myFSymbol = '\u2079';
			      break;
			}
			switch (myRange[i].characters[2].contents) 
			{
			   case '1':
			      var mySSymbol = '\u2081';
			      break;
			   case '2':
			      var mySSymbol = '\u2082';
			      break;
			   case '3':
			      var mySSymbol = '\u2083';
			      break;
			   case '4':
			      var mySSymbol = '\u2084';
			      break;
			   case '5':
			      var mySSymbol = '\u2085';
			      break;
			   case '6':
			      var mySSymbol = '\u2086';
			      break;
			   case '7':
			      var mySSymbol = '\u2087';
			      break;
			   case '8':
			      var mySSymbol = '\u2088';
			      break;
			   case '9':
			      var mySSymbol = '\u2089';
			      break;
			}
			var myReplace = myFSymbol + myFrSlash + mySSymbol;
			findPreferences = undefined;
			changePreferences = undefined;
			changePreferences.appliedCharacterStyle = myNameStyle;
			myStory.search(mySearch, true, false, myReplace);
			findPreferences = undefined;
			changePreferences = undefined;
			findPreferences.appliedCharacterStyle = myNameStyle;
			changePreferences.tracking = 0;		
			myStory.search(mySSymbol, false, false, mySSymbol);		
			findPreferences = undefined;
			changePreferences = undefined;
			findPreferences.appliedCharacterStyle = myNameStyle;
			if (myFont == 'Myriad Pro') {
			if (myNameStyle == 'HorizontalFractionStyle') {
				changePreferences.baselineShift = 1;
			}
			}			
			myStory.search(myFrSlash, false, false, myFrSlash);		
			findPreferences = undefined;
			changePreferences = undefined;
} // Type of fraction end
} // Range End
} // result true end
} // if selection.constructor validate end
} // with app end